﻿using System.Threading;
using System.Windows;
using System.Windows.Threading;
using Telerik.Windows.Controls;
using System;

namespace RadButtonBug
{
	public class MainPageViewModel : ViewModelBase
	{
		private bool _isTestEnabled;

		public DelegateCommand TestCommand { get; set; }
		public DelegateCommand TestCommand1 { get; set; }
		public DelegateCommand TestCommand2 { get; set; }
		public DelegateCommand TestCommand3 { get; set; }
		public DelegateCommand TestCommand4 { get; set; }
		public DelegateCommand TestCommand5 { get; set; }

		public DelegateCommand ToggleCommand { get; set; }
		public DelegateCommand GetBusyCommand { get; set; }

		public Dispatcher Dispatcher { get; set; }

		public bool ShouldBeEnabled
		{
			get
			{
				return _isTestEnabled;
			}
		}

		private bool _isBusy;
		public bool IsBusy
		{
			get { return _isBusy; }
			set
			{
				_isBusy = value;
				this.OnPropertyChanged(() => IsBusy);
			}
		}

		public MainPageViewModel(Dispatcher dispatcher)
		{
			TestCommand = new DelegateCommand(DoTest, CanExecuteTest);
			TestCommand1 = new DelegateCommand(DoTest, CanExecuteTest);
			TestCommand2 = new DelegateCommand(DoTest, CanExecuteTest);
			TestCommand3 = new DelegateCommand(DoTest, CanExecuteTest);
			TestCommand4 = new DelegateCommand(DoTest, CanExecuteTest);
			TestCommand5 = new DelegateCommand(DoTest, CanExecuteTest);
			ToggleCommand = new DelegateCommand(Toggle);
			GetBusyCommand = new DelegateCommand(GetBusy);
			Dispatcher = dispatcher;
		}

		private void GetBusy(object sender)
		{
			ThreadPool.QueueUserWorkItem(s =>
				{
					Dispatcher.BeginInvoke(() => IsBusy = true);
					Thread.Sleep(500);
					Dispatcher.BeginInvoke(() => Toggle(null));
					Thread.Sleep(500);
					Dispatcher.BeginInvoke(() => IsBusy = false);
				});
		}

		private void Toggle(object s)
		{
			_isTestEnabled = !_isTestEnabled;
			TestCommand.InvalidateCanExecute();
			TestCommand1.InvalidateCanExecute();
			TestCommand2.InvalidateCanExecute();
			TestCommand3.InvalidateCanExecute();
			TestCommand4.InvalidateCanExecute();
			TestCommand5.InvalidateCanExecute();

			this.OnPropertyChanged(() => ShouldBeEnabled);
		}

		private void DoTest(object sender)
		{
			if (sender != null)
				MessageBox.Show(sender.ToString());
			else
				MessageBox.Show("Some test");
		}

		private bool CanExecuteTest(object sender)
		{
			return _isTestEnabled;
		}
	}
}